;;; start.lisp
;;;
;;; Copyright (C) 2008-2009 Alessio Stalla
;;;
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
;;;
;;; As a special exception, the copyright holders of this library give you
;;; permission to link this library with independent modules to produce an
;;; executable, regardless of the license terms of these independent
;;; modules, and to copy and distribute the resulting executable under
;;; terms of your choice, provided that you also meet, for each linked
;;; independent module, the terms and conditions of the license of that
;;; module.  An independent module is a module which is not derived from
;;; or based on this library.  If you modify this library, you may extend
;;; this exception to your version of the library, but you are not
;;; obligated to do so.  If you do not wish to do so, delete this
;;; exception statement from your version.

(in-package :snow)

(defun snow-about ()
  (dialog (:id dlg :title "Snow v0.3" :visible-p t)
    (label :layout "wrap"
	   :text "Snow version 0.3")
    (label :layout "wrap"
	   :text "Copyright (C) 2008-2010 Alessio Stalla")
    (label :layout "wrap"
	   :text "This program is distributed under the GNU GPL; see the file copying for details.")
    (label :layout "wrap"
	   :text "Many thanks to these people for contributing to Snow:")
    (label :layout "wrap"
	   :text "Nikita \"Shviller\" Mamardashvili")
    (button :text "Ok" :on-action (lambda () (dispose dlg)))
    (pack self)))

(defun snow-showcase ()
  (unless (find-package '#:snow-showcase)
    ;;loads the showcase file
     (jstatic (jmethod "snow.Snow" "evalResource" "java.lang.String") nil "/snow/showcase/showcase.lisp"))
  (funcall (symbol-function (find-symbol (symbol-name '#:showcase)
					 (find-package '#:snow-showcase)))))

(with-gui ()
  (frame (:id frame :title "ABCL - Snow REPL"
	  :size #C(800 300)
          :visible-p t :layout-manager '(:mig "fill" "[fill]" "")
	  :on-close :exit
	  :menu-bar (menu-bar ()
		      (menu (:text "File")
			(menu-item :text "Quit"
				   :on-action (lambda () (ext:quit))))
		      (menu (:text "Help")
			(menu-item :text "Showcase"
				   :on-action (lambda () (snow-showcase)))
			(menu-item :text "About"
				   :on-action (lambda () (snow-about))))))
    (scroll (:layout "grow")
      (gui-repl :dispose-on-close frame
		:environment `((*package* ,(find-package :snow-user))
			       (*readtable* ,(find-readtable 'snow:syntax)))))))
